{$R-,Q-,S-,Q-}
{  }
Uses crt;                                  { for keypressed only }

{$i pal_fire.src}

var BiosTicks: longint absolute $0040:$006C;

const
  Flakes = 500;            { try less flakes for faster snowfall }
  const fading:integer=0;

{---------------- Stuff not specific to snowfall ----------------}
Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr2;

procedure line(x1,y1,x2,y2:integer);
var i,j:integer;
begin
  I := Abs(X2-X1);
  j := abs(y2-y1);
  if i<j then i:=j;

  for j := 0 to i do begin
    scr4^[320*(y1+round((y2-y1)/i*j))+x1+round((x2-x1)/i*j)] := 255;
  end;
end;

procedure WASH(var SOURCE, DEst); assembler;
label M1, M2;
asm
  push ds
  push es

  mov  dx, fading
  xor  dh,dh
  mov  ds, word ptr [dest+2]
  mov  es, word ptr [source+2]
  xor  si,si
  xor  di,di

  xor  bx,bx

m1:
  xor  ah,ah
(**)
  mov  al,[es:si]
  shl  ax,1
  mov  bl,[es:si]
  add  ax,bx
  shl  ax,1
  mov  bl,[es:si]
  add  ax,bx
  shl  ax,2
  mov  bl,[es:si+1]
  add  ax,bx
  mov  bl,[es:si-1]
  add  ax,bx
  mov  bl,[es:si+320]
  add  ax,bx
  mov  bl,[es:si-320]
  add  ax,bx
  shr  ax,5
  mov  [ds:di],al
  sub  al, dl
  jb   m2
  mov  [ds:di],al
m2:
  dec  di
  dec  si
  jnz  m1

  pop  es
  pop  ds
end;

procedure movs(var source, dest); assembler;
asm
  push ds
  push es
  mov  es, word ptr [dest+2]
  mov  ds, word ptr [source+2]
  xor  si,si
  xor  di,di
  mov  cx, $4000
  cld
  db $66     { \\\           }
  rep  movsw { /// rep movsd }
  pop  es
  pop  ds
end;

type TFont=array[0..32767] of Byte;
var  Font:^TFont absolute 0:$10C;
const FontHeight:Byte=8;
const FontScale:Byte=4;

{---------------------------MAIN PROGRAM-------------------------}

var
  I : Longint;                       { to add velocity to flakes }
  J,K: Word;
  TMPPtr:Pointer;
  s:string;
label m1,m2,mexit;
BEGIN
  Randomize;

  vidMode($13);                       { 320x200x256 graphics mode }


  for I:=0 to 199 do
    for J:=0 to 7 do
      Scr[I,J]:=((Font^[I] shr J) and 1)*255;

  ReadKey;
  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  FillChar(Scr4^,65535,#0);

  SetPalette;

  I:=0;
  repeat

    for J:=0 to 7 do
      for K:=0 to FontScale-1 do
      Scr4^[199*320+32+J*FontScale+K]:=((Font^[65*FontHeight+(I div FontScale) mod FontHeight] shr J) and 1)
        *Random(256);

    wash(scr4^,scr3^);
    MOVS(Scr3^, Scr2);
{    TMPPtr:=Scr3; Scr3:=Scr4; Scr4 := TMPPtr;
{    movs(Scr3^, Scr4^);}
    Move(Scr3^[320],Scr4^,320*199); { ᭮ }
{    move(Scr3^[8192],Scr4^,65535); {'' }

    if keypressed then case readkey of
      '-': inc(fading);
      '+': dec(fading);
      '*': fading :=0;
      #27: goto mexit;
    end;
    Inc(I);
  until False;

  mexit:
  vidMode($03);                       { return to 80x25 textmode }
end.

