{$R-,Q-,S-,Q-}
{  }
uses Crt;                                  { for keypressed only }

{$i pal_fire.src}

var BiosTicks: longint absolute $0040:$006C;

const
  Flakes = 500;            { try less flakes for faster snowfall }
  const fading:integer=0;

{---------------- Stuff not specific to snowfall ----------------}
Procedure vidMode(mode : byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of byte absolute $A000:$0000;
type TScr2 = array[0..63999] of byte;
var Scr2: TScr2 absolute $A000:$0000;
var Scr3, Scr4: ^TScr2;

procedure line(x1,y1,x2,y2:integer);
var I,J:Integer;
begin
  I := Abs(X2-X1);
  j := abs(y2-y1);
  if i<j then i:=j;

  for J := 0 to I do begin
    Scr4^[320*(Y1+Round((Y2-Y1)/I*J))+X1+Round((X2-X1)/I*J)] := 255;
  end;
end;

procedure WASH(var SOURCE, DEst); assembler;
label M1, M2;
asm
  push ds
  push es

  mov  dx, fading
  xor  dh,dh
  mov  ds, word ptr [dest+2]
  mov  es, word ptr [source+2]
  mov  si,160*50-1
  mov  di,160*50-1

  xor  bx,bx

m1:
  xor  ah,ah
(**)
  mov  al,[es:si]
  shl  ax,2
  mov  bl,[es:si+1]
  add  ax,bx
  mov  bl,[es:si-1]
  add  ax,bx
  mov  bl,[es:si+160]
  add  ax,bx
  mov  bl,[es:si-160]
  add  ax,bx
  shr  ax,3
  mov  [ds:di],al
  sub  al, dl
  jb   m2
  mov  [ds:di],al
m2:
  dec  di
  dec  si
  jnz  m1

  pop  es
  pop  ds
end;

procedure movs(var source, dest); assembler;
asm
  push ds
  push es
  mov  es, word ptr [dest+2]
  mov  ds, word ptr [source+2]
  xor  si,si
  xor  di,di
  mov  cx, $4000
  cld
  db $66     { \\\           }
  rep  movsw { /// rep movsd }
  pop  es
  pop  ds
end;

type TFont=array[0..32767] of Byte;
var  Font:^TFont absolute 0:$10C;
const FontHeight:Byte=8;
const FontScale:Byte=2;

{---------------------------MAIN PROGRAM-------------------------}
const SMOOTH:Boolean=False;

var
  I : Longint;                       { to add velocity to flakes }
  IX,IY: Word;
  J,K: Word;
  TMPPtr:Pointer;
  s:string;
label m1,m2,mexit;
BEGIN
  Randomize;

  vidMode($13);                       { 320x200x256 graphics mode }


  for I:=0 to 199 do
    for J:=0 to 7 do
      Scr[I,J]:=((Font^[I] shr J) and 1)*255;

  ReadKey;
  GetMem(Scr3,65535);
  GetMem(Scr4,65535);
  FillChar(Scr4^,65535,#0);

  SetPalette;

  I:=0;
  repeat

    for J:=0 to 7 do
      for K:=0 to FontScale-1 do
      Scr4^[99*160+32+J*FontScale+K]:=((Font^[65*FontHeight+(I div FontScale) mod FontHeight] shr J) and 1)*255;

    WASH(Scr4^,Scr3^);
    Move(Scr4^[160*50],Scr3^[160*50],160*50);
    for IY:=0 to 99 do
      for IX:=0 to 159 do begin
       if not SMOOTH then begin
        Scr[IY shl 1,IX shl 1] := Scr3^[IY*160+IX];
        Scr[IY shl 1,IX shl 1+1] := Scr3^[IY*160+IX];
        Scr[IY shl 1+1,IX shl 1] := Scr3^[IY*160+IX];
        Scr[IY shl 1+1,IX shl 1+1] := Scr3^[IY*160+IX];
       end else begin
        Scr[IY shl 1,IX shl 1] := Scr3^[IY*160+IX];
        Scr[IY shl 1,IX shl 1+1] := Scr3^[IY*160+IX] shr 1+Scr3^[IY*160+IX+1] shr 1;
        Scr[IY shl 1+1,IX shl 1] := Scr3^[IY*160+IX] shr 1+Scr3^[(IY+1)*160+IX] shr 1;
        Scr[IY shl 1+1,IX shl 1+1] := Scr3^[IY*160+IX] shr 1+Scr3^[(IY+1)*160+IX+1] shr 1;
       end;
      end;
{    TMPPtr:=Scr3; Scr3:=Scr4; Scr4 := TMPPtr;
{    movs(Scr3^, Scr4^);}
    Move(Scr3^[160],Scr4^,160*99); { ᭮ }
{    move(Scr3^[8192],Scr4^,65535); {'' }

    if keypressed then case readkey of
      '-': inc(fading);
      '+': dec(fading);
      '*': FADing :=0;
      ^M:  SMOOTH:=not SMOOTH;
      #27: goto MExit;
    end;
    Inc(I);
  until False;

  mexit:
  vidMode($03);                       { return to 80x25 textmode }
end.

