{$R-,Q-,S-,Q-}
uses Crt;

{-$i pal_rad.src}
procedure SetPalette;
var   N:Integer;
begin
  Port[$3C8] := 0;
  for N := 0 to 256*3-1 do
    Port[$3C9] := Round(Sqr(Sin(N*21167.0{PI*257/3/256}))*63);
end; {of SetPalette}

var BIOSTicks: Longint absolute $0040:$006C;

procedure VIDMode(Mode : Byte);assembler;
  asm mov ah,$00;  mov al,mode; int 10h; end;

var Scr: array[0..199,0..319] of Byte absolute $A000:$0000;

type TFont=array[0..32767] of Byte;
var  Font:^TFont absolute 0:$10C;
const FontHeight:Byte=8;
const FontScale:Byte=2;

{---------------------------MAIN PROGRAM-------------------------}

var
  I : Longint;
  J,K,L: Word;
const S:string='Very long test string... ';
BEGIN
  Randomize;

  VIDMode($13);                       { 320x200x256 graphics mode }


  for I:=0 to 199 do
    for J:=0 to 7 do
      Scr[I,J]:=((Font^[I] shr J) and 1)*255;

  ReadKey;

  SetPalette;

  I:=0;
  repeat

    for K:=1 to Length(S) do begin
      for L:=0 to 7 do
        for J:=0 to 7 do begin
(*          if I<>0 then
          Dec(Scr[80+L*FontScale{+Round(4*Sin(((-(I-1)/2+K)*8-J)*2*PI/64))}
             ,50+(-J+K*8)*FontScale]
             ,((Font^[Ord(S[K])*8+L] shr J) and 1)*(I-1+(L*2-J+K*8)*4));
          Inc(Scr[80+L*FontScale{+Round(4*Sin(((-I/2+K)*8-J)*2*PI/64))}
             ,50+(-J+K*8)*FontScale]
             ,((Font^[Ord(S[K])*8+L] shr J) and 1)*(I+(L*2-J+K*8)*4));
*)
          if Sin((-I/2-J+K*8)*PI/128)>0 then begin
            Scr[80+L*FontScale,160+Round(-Cos((-I/2-J+K*8)*PI/128)*64)]:=
               Round(Sin((-I/2-J+K*8)*PI/128)*192)*((Font^[Ord(S[K])*8+L] shr J) and 1);
{               ((Font^[Ord(S[K])*8+L] shr J) and 1)*(I+(L*2-J+K*8)*4);{}
            Scr[80+L*FontScale+1,160+Round(-Cos((-I/2-J+K*8)*PI/128)*64)]:=
               Round(Sin((-I/2-J+K*8)*PI/128)*192)*((Font^[Ord(S[K])*8+L] shr J) and 1);
{               ((Font^[Ord(S[K])*8+L] shr J) and 1)*(I+(L*2-J+K*8)*4);{}
          end;
        end;
    end;
    if KeyPressed then case ReadKey of
      ' ': ReadKey;
      #27: Break;
    end;
    Inc(I);
  until False;

  vidMode($03);                       { return to 80x25 textmode }
end.

